<?php if (!defined('HTTP_SERVER')) die('You can not access this file directly!');
/**
  @licence GPL 2005-2010  The osCSS developers - osCSS Open Source E-commerce
  @package oscss-2 <www http://www.oscss.org>
  @version 2.0.9
  @date  22/08/10, 09:26
  @author oscim <mail aurelien@oscim.fr> <www http://www.oscim.fr>
  @encode UTF-8
  @class emailUtility
*/
class emailUtility {



  /**
    Send email (text/html) using MIME
    This is the central mail function. The SMTP Server should be configured correct in php.ini
  @Param
    $to_name           The name of the recipient, e.g. "Jan Wildeboer"
    $to_email_address  The eMail address of the recipient,
    e.g. jan.wildeboer@gmx.de
    $email_subject     The subject of the eMail
    $email_text        The text of the eMail, may contain HTML entities
    $from_email_name   The name of the sender, e.g. Shop Administration
    $from_email_adress The eMail address of the sender,
    e.g. info@mytepshop.com

  @return boolean true /false
  */
  public static function tep_mail($to_name, $to_email_address, $email_subject, $email_text, $from_email_name='', $from_email_address='') {
    if(empty($from_email_address))$from_email_address=EMAIL_FROM;
    if(empty($from_email_name))$from_email_name=STORE_OWNER;
    if (!_cst_bool('SEND_EMAILS')) return false;

    $send_obj_message = new email(array('X-Mailer: osCSS'));
    $text = strip_tags($email_text);
    if (_cst_bool('EMAIL_USE_HTML')) $send_obj_message->add_html($email_text, $text);
    else $send_obj_message->add_text($text);

    $send_obj_message->build_message();
    if( ($send_obj_message->send($to_name, $to_email_address, $from_email_name, $from_email_address, $email_subject)) !=false) return true;
    else return false;
  }


  /**
    @package oscss-Rv
    @author oscim - OscssTeam
    @version 1.0
    Construteur de mise en forme des email avant envoi; remplace les code raccouris et ajoute si necessaire l'entete html
  */
  public static function replace_for_mail($txt_mail,$subject,$html_reg,$text_reg,$mode='HTML'){
      /* Code raccourcis autorisé */
	$array_code_racc=array('genre','firstname','lastname', 'email_address', 'numero_client', 'signature','license','desinscription');

      foreach ($array_code_racc as $item) {
	  if ($mode == 'HTML'){
	      if (preg_match('/\['.$item.'\]/i',$txt_mail) && isset($html_reg[$item]))  $txt_mail = preg_replace('/\['.$item.'\]/i',$html_reg[$item],$txt_mail);
	  } else {
	      if (preg_match('/\['.$item.'\]/i',$txt_mail) && isset($text_reg[$item])) $txt_mail = preg_replace('/\['.$item.'\]/i',$text_reg[$item],$txt_mail);
	  }
      }
      return $txt_mail;
  }


  /**
    Construteur de mise en forme des email avant envoi; remplace les code raccouris et ajoute si necessaire l'entete html
    @param
      @a string nom du template
      @a string path du language utilis pour le mail
      @a array $myarray key/value des var perso
      @a boolean return / print
  */
  public static function post_prepare_email($template,$language,$myarray,$print=false){
    global $title_email,$messageStack;
    $template=(tep_not_null($template))? $template : 'defaut.tpl' ;
    include(DIR_WS_LANGUAGES . $language .'/modules/template_email/'.substr($template, 0, strlen($template)-4) .'.txt');

    $title_email=$lang['EMAIL_TEXT_SUBJECT'];
    if(!defined('EMAIL_TEXT_SUBJECT'))define('EMAIL_TEXT_SUBJECT',$lang['EMAIL_TEXT_SUBJECT']);

    $tpl = &Template::singleton();
    if (!empty($tpl->error)) {
      $messageStack->add_session($tpl->error, 'error');
      return false;
    }
    $tpl->template_dir =  DIR_WS_MODULES . 'template_email/';
    $tpl->assign("STORE_LOGO_PRINT",STORE_LOGO_PRINT);
    $tpl->assign("DIR_WS_CATALOG", DIR_WS_CATALOG);
    $tpl->assign("DIR_WS_ADMIN", DIR_WS_ADMIN);
    $tpl->assign("HTTP_CATALOG_SERVER", HTTP_CATALOG_SERVER);
    $tpl->assign("DIR_WS_IMAGES", DIR_WS_IMAGES.'mail/');
    $tpl->assign("DIR_WS_LANGUAGES", DIR_WS_LANGUAGES);
    $tpl->assign("CHARSET", CHARSET);
    $tpl->assign("STORE_NAME", STORE_NAME);
    $tpl->assign("myarray", $myarray);
    $tpl->assign("TPL_CONTENT", addslashes($myarray['message']));
    if (isset($lang) && is_array($lang))$tpl->assign("lg", $lang);

    if(!$print) return $tpl->get($template);
    else return $tpl->display($template);
  }

  /**
      Recup element dirs
    @package oscss-Rv
    @author oscim
    @version 1.0
  */
  public static function recup_template_mail(){
    $dirs = dir( DIR_WS_MODULES . 'template_email/');
    $t[]=array('id'=>'', 'text'=>TEXT_TPL_AUCUN );
    while ($file = $dirs->read()) {
      if (substr("$file", -4) == '.tpl') {
	$name=substr("$file",0,strlen($file)-4);
	$t[]=array('id'=>$file, 'text'=>$name );
      }
    }
    $dirs->close();
    return $t;
  }

}
?>
