<?php
/**
  @licence GPL 2005-2011  The osCSS developers - osCSS Open Source E-commerce
  @portion code Copyright (c) 2002 osCommerce
  @package osCSS-2 <www http://www.oscss.org>
  @version 2.1.0
  @date  23/02/11, 08:59
  @author oscim <mail aurelien@oscim.fr> <www http://www.oscim.fr>
  @encode UTF-8
*/

/**
  @author oscim <mail oscim@oscss.org> <www http://www.oscim.fr>
  @param
    @a string $_GET['mode_view']
    @a int $_GET['width']
*/
function Sales($mini=true){

  $an= (isset($_GET['year'])?$_GET['year'] :2010);
  $an_end= (isset($_GET['year_end'])?$_GET['year_end'] :2010);

  $val=new Sales($an,'','',$an_end);
  $stats=$val->value;
  $les_color=$val->les_color;
  $les_color_name=$val->les_color_name;


  $get=tep_extrac_querystring();

  $banner_extension='png';

  $mode=(isset($get['mode_view'])) ? $get['mode_view'] : 'stackedbars';
  $banner_id=$width=isset($_GET['width'])? ((int)$_GET['width']-50) : 250 ;
  $height=$width/3;
  $img=DIR_WS_IMAGES . 'graphs/sales_products-' . $banner_id .'-'.$mode .'.'. $banner_extension;

  $graph = new PHPlot($width, $height,$img );

  $graph->SetFileFormat($banner_extension);
  $graph->SetIsInline(1);
  $graph->SetPrecisionY(0);
  $graph->SetDataType('text-data');


  //! bordure ext
  $graph->SetImageBorderType('plain');

  $graph->SetPlotType($mode); // bars, stackedbars, lines, linepoints, area, points, pie, thinbarline, squared, stackedarea

  //! SetPlotType= linepoints
  $graph->SetPointSizes(10); // int
  $graph->SetPointShapes('line'); //halfline, line, plus, cross, rect, circle, dot, diamond, triangle, trianglemid, delta, yield, star, hourglass, bowtie, target, box, home, up, down, none
  $graph->SetLineStyles('solid'); // dashed, solid, none

  $graph-> SetDrawXDataLabelLines ('lines'); //lines, points, linepoints, thinbarline

  $graph->SetPlotBorderType('none'); // left, sides, none, full

  $graph->SetDrawBrokenLines(true);
  $graph->SetLabelScalePosition(0.5);

  $graph->SetPointShapes('cross'); //halfline, line, plus, cross, rect, circle, dot, diamond, triangle, trianglemid, delta, yield, star, hourglass, bowtie, target, box, home, up, down, none'

  $graph->SetPlotBorderType( "left");
//   $graph->SetVertTickPosition('plotleft');
  $graph->SetDataValues($stats);
  $graph->SetDataColors($les_color,$les_color);
//   $graph->SetTransparentColor($les_color[1]);

  //! 3D
  $graph->SetShading(true);

  //! couleur de fond et arriere plan
//   $graph->SetDrawPlotAreaBackground( true );
//   $graph->SetPlotBgColor( "#cccccc");
  $graph->SetBackgroundColor('#f0f0ee');
  $graph->SetTransparentColor('#f0f0ee');

  //! grille
  $graph->SetDrawDashedGrid ('dashed') ; //solid or dashed
  $graph->SetDefaultDashedStyle('4-3');
  $graph->SetLightGridColor( "#828282");

  //! font , et taille
  $graph->SetTitleFontSize('3');
  $graph->SetTTFPath(DIR_FS_CATALOG.DIR_WS_COMMON_FONTS);
  $graph->SetDefaultTTFont('arial.ttf');
  $graph->SetFontTTF('x_label', 'arial.ttf','8');
  $graph->SetFontTTF('y_label', 'arial.ttf','8');
  $graph->SetFontTTF('legend', 'arial.ttf','10');

  if($mini){
    //! tableau legende
    $graph->SetLegend($les_color_name);

    //! Title
    $graph->SetTitle(TITLE_GRAPH_SALES);
  }

  //! label
//   $plot->SetTitle('Candy Sales by Month and Product');
//   $plot->SetYTitle('Millions of Units');
//   $plot->SetXTitle('Millions of Units');
  $graph->SetXTickLabelPos('none');
  $graph->SetXTickPos('none');
  $graph->SetTextColor('#666666');

  if($mini){
    //! pos label X
    $graph->SetXDataLabelPos ('plotup') ; // plotup,plotdown,both, none
    $graph->SetXTickPos('none');
    //! Turn on Y data labels:
    $graph->SetYDataLabelPos('none'); // plotin, none
    $graph->SetYTickPos('none');
    //! incrementation
    $graph->SetVertTickIncrement( "200");
  } else {
    //! pos label X
    $graph->SetXDataLabelPos ('none') ; // plotup,plotdown,both, none
    $graph->SetXTickPos('none');
    //! Turn on Y data labels:
    $graph->SetYDataLabelPos('none'); // plotin, none
    $graph->SetYTickPos('none');
    //! incrementation
    $graph->SetVertTickIncrement( "1000");
  }

  $graph->DrawGraph();

  $graph->PrintImage();

// echo $img;
  if(isset($_GET['print']))  echo tep_image($img, '','',''). "\n";
  else return $img;
}


/**
  @author oscim <mail oscim@oscss.org> <www http://www.oscim.fr>
  @class Sales
*/
class Sales{
  /**
    nombre de statsu de order present
  */
  var $nbr_val;
  /**
    tableau de couleur de status
  */
  var $les_color;
  /**
    tableau de couleur de status
  */
  var $base_date;


  function __construct($year='',$month='',$day='',$year_end=''){
    $this->base_year=$year=(!empty($year)? $year : date("Y") );
    $year_end=(!empty($year_end)? $year_end : date("Y") );

    $this->base_date =$year.'-'.(!empty($month)? $month : '00') . '-'.(!empty($day)? $day : '00');

    $this->les_status();

    /**
      Tableau mensuel base
    */
    $amplitude=($year_end-$year);
    for($ir=0; $ir<=$amplitude; $ir++ ) {
      for($i=0; $i<12; $i++ ) {
	$s[(($ir*12)+$i)][0]='txt';
	for($is=1; $is<=$this->nbr_val; $is++ )
	  $s[(($ir*12)+$i)][$is]=0;
      }

    }
    $this->value=$s;

    $this->tab_for_order();
  }



  /**
    Mise en tableau et prepa des valeur
  */
  private function tab_for_order(){
    if( ($query=$this->les_orders()) ==false) return null;

    while ($orders = tep_db_fetch_array($query)){
      preg_match('/([0-9.]*)/i',strip_tags($orders['order_total']),$match);
      $value_sommme=$match[1];
      $mit=($orders['mois']-1);
      $anne=($this->base_year==$orders['annee'])? 0  : (($orders['annee']-$this->base_year)*12);

      if(isset($this->value[($anne+$mit)])){
	if($this->value[($anne+$mit)][0]=='txt') $this->value[($anne+$mit)][0] =date("m-y",strtotime($orders['date_purchased']));

	if($this->value[($anne+$mit)][$orders['orders_status']]==0) $this->value[($anne+$mit)][$orders['orders_status']] =$value_sommme;
	else  $this->value[($anne+$mit)][$orders['orders_status']] +=$value_sommme;
      }
    }

  }

  /**
    Recup orders
  */
  private function les_orders(){
    global $languages_id;
    $DB=Database::getInstance();
    $orders_query_raw = $DB->query($sql=" select EXTRACT(YEAR FROM o.date_purchased) AS annee, EXTRACT(MONTH FROM o.date_purchased) AS mois, o.date_purchased, o.last_modified, o.currency, o.currency_value, o.orders_status, s.status_name as orders_status_name, ot.text as order_total from " . TABLE_ORDERS . " o left join " . TABLE_ORDERS_TOTAL . " ot on (o.orders_id = ot.orders_id), " . TABLE_STATUS . " s where o.orders_status = s.status_id and status_type='orders' and s.language_id = '" . (int)$languages_id . "' and ot.class = 'ot_total' and o.date_purchased > '".$this->base_date."' GROUP by year(o.date_purchased), month(o.date_purchased),o.orders_status ORDER BY year(o.date_purchased) ASC, month(o.date_purchased) ASC ");

    if ($orders_query_raw->__get('numRows') > 0) return $orders_query_raw;
    else return false;
  }


  /**
    Recup status
  */
  private function les_status(){
    global $languages_id;
    $DB=Database::getInstance();
    $status_color = $DB->query("select status_id as orders_status_id, status_name as orders_status_name, status_color as orders_status_color FROM ".TABLE_STATUS." where status_type='orders' and  language_id = '" . (int)$languages_id . "' ");
    while ($sales_products = $status_color->fetchAssoc()) {
	$this->les_color[]=$this->html2rgb($sales_products['orders_status_color']);
	$this->les_color_name[]=utf8_decode($sales_products['orders_status_name']);
      }
      $this->nbr_val=count($this->les_color);
  }

  /**
    convertion color
  */
  private function html2rgb($color) {
      if ($color[0] == '#')
	  $color = substr($color, 1);

      if (strlen($color) == 6)
	  list($r, $g, $b) = array($color[0].$color[1],
				  $color[2].$color[3],
				  $color[4].$color[5]);
      elseif (strlen($color) == 3)
	  list($r, $g, $b) = array($color[0].$color[0], $color[1].$color[1], $color[2].$color[2]);
      else
	  return false;

      $r = hexdec($r); $g = hexdec($g); $b = hexdec($b);

      return array($r, $g, $b);
  }
}
?>