<?php if (!defined('HTTP_SERVER')) die('You can not access this file directly!');
/**
  @licence GPL 2005-2010  The osCSS developers - osCSS Open Source E-commerce
  @portion code Copyright (c) 2002 osCommerce
  @package osCSS-2 <www http://www.oscss.org>
  @version 2.1.0
  @date  18/12/10, 22:49
  @author oscim <mail aurelien@oscim.fr> <www http://www.oscim.fr>
  @encode UTF-8
  @class orders
  @brief manage orders, listing and edit status
*/


class orders
  implements ExtModPage, InterfacedTJsonS, InterfacedInnerHtml {

  /**
    @param const
  */
  const FILENAME = FILENAME_ORDERS;
  /**
    @param string code, le nom de la class
  */
  public static $code;
  /**
    @param string action, passé en GET
  */
  public static $action;
  /**
    @param array list, utilisé dans les gabarits, list des orders
  */
  public static $list=array();
  /**
    @param object $order
  */
  public static $order;
  /**
    @param int Id order
  */
  public static $oID;
  /**
    @param bool $update autorise mise a jour status
  */
  public static $update;
  /**
    @param array $orders_status_array
  */
  public static $orders_status_array=array();
  /**
    @param array $orders_statuses
  */
  public static $orders_statuses=array();
  /**
    @param object $oInfo
  */
  public static $oInfo;
  /**
    @param object $export
  */
  public static $export;



  /**
    class constructor
  */
  public function __construct() {
    self::$code=__CLASS__;

    //! active datatable in ajax format, precise les GET necessaire
    define('JSONSTATMENT', 'mod=page&type='.self::$code);
    //! detail item in ajax
    define('AJAXSTATMENTDETAIL', 'mod=page&type='.self::$code);

    self::$export= new export();

    self::init();
  }

  public function check_action($actions){
    global $messageStack,$page_module;

    self::$action=$actions;

    switch (self::$action) {
    case 'multi':
        $res=array();
        /**
          Action mutliple
        */
        $status = tep_db_prepare_input(@$_POST['status_multi']);
// 	$modeexport = tep_db_prepare_input(@$_POST['modeexport']);
        $notify_comments = (isset($_POST['notify_comments'])) ? tep_db_prepare_input($_POST['notify_comments']) : '';
        $notify =(isset($_POST['notify'])) ? tep_db_prepare_input($_POST['notify']): '';
        $comments= (isset($_POST['comments'])) ? tep_db_prepare_input($_POST['comments']) :'';
        if(isset($_POST['action_multi']) && is_array($_POST['action_multi']) ) {

	    if(isset($_POST['status_multi'])){
	      foreach($_POST['action_multi'] as $oID )
		if (up_status_order($oID, array('status'=>$status,'comments'=>'', 'notify'=>$notify, 'notify_comments'=>$notify_comments , 'comments'=> $comments)  ) ) $res[]=true;
		else $res[]=false;
	    }
	    if(isset($_POST['modeexport'])){

	      $modeexport=tep_db_prepare_input($_POST['modeexport']);
	      $encodage=tep_db_prepare_input($_POST['encodage']);
	      $export_type=tep_db_prepare_input($_POST['export_type']);
	      $od=array();

	      self::$export->pre_export(array( 'mode' => $modeexport, 'encodage'=>$encodage, 'export_type'=>$export_type, 'page_admin'=>$page_module));

	      foreach($_POST['action_multi'] as $oID ){

		$order = new order((int)$oID);
		$qer=tep_db_query("SELECT countries_iso_code_2 FROM  " . TABLE_COUNTRIES . " WHERE countries_name='".$order->customer['country']."' ");
		$c=tep_db_fetch_array($qer);

		$od[]=array('IDExpedition'=>$oID,
			    'IDCustomer'=>$order->customer['id'],
			    'Namecustomer'=>self::$export->decodage($order->customer['name']),
			    'Compagnycustomer'=>self::$export->decodage($order->customer['company']),
			    'Streetadress'=>self::$export->decodage($order->delivery['street_address']),
			    'Streetadress2'=>self::$export->decodage($order->delivery['suburb']) ,
			    'Cityshipping'=>self::$export->decodage($order->delivery['city']),
			    'Stateshipping'=>self::$export->decodage($order->customer['state']) ,
			    'telephone'=>self::$export->decodage($order->customer['telephone']),
			    'postcode'=>self::$export->decodage($order->delivery['postcode']),
			    'codecountryiso'=>$c['countries_iso_code_2'],
			    'weight'=>round($order->info['total_weight'],3),
			    'Contreremb'=>'');
	      }

	      self::$export->op_export($od);
	    }
        }

        if (in_array(false,$res))  $messageStack->add_session(__('success order updated'), 'success');
        else  $messageStack->add_session(__('warning order not updated'), 'warning');

        tep_redirect(tep_href_link(self::FILENAME));
      break;
      case 'update_order':
	$oID=(int)$_GET['oID'];
        if (up_status_order($oID, $_POST) )  $messageStack->add_session(__('success order updated'), 'success');
        else  $messageStack->add_session(__('warning order not updated'), 'warning');

        tep_redirect(tep_href_link(self::FILENAME,  'oID='.$oID.'&action=edit'));
      break;

      case 'deleteconfirm':
	$oID=(int)$_GET['oID'];
        delete_order($oID);
        tep_redirect(tep_href_link(self::FILENAME));
      break;

   }

    return self::$action;
  }

  public function get_header(){
    if (self::$action == 'edit'): ?>
    <script type="text/javascript"><!--
    function disabled(inputs){$(inputs).css.display='none';}
    function activ(inputs){$(inputs).css.display='inline';}
    $(function() {disabled('#cont_comments');});
    //--></script>
    <?php endif;
  }


  public static function load_db_values($ID){
    global $languages_id;
    $DB=Database::getInstance();
    $ID = tep_db_prepare_input($ID);
    $orders_query_raw = "select distinct o.orders_id,o.orders_prefix,  o.customers_id,o.customers_name,  o.payment_method, o.date_purchased, o.last_modified, o.currency, o.currency_value, s.status_name as orders_status_name, s.status_color as orders_status_color,ot.text as order_total from " . TABLE_ORDERS . " o left join " . TABLE_ORDERS_TOTAL . " ot on (o.orders_id = ot.orders_id), " . TABLE_STATUS . " s where o.orders_status = s.status_id and s.status_type='orders'  and s.language_id = '" . (int)$languages_id . "' and ot.class = 'ot_total' and o.orders_id='".$ID."' ";

    $currency_query = $DB->query($orders_query_raw);

    return new objectInfo($currency_query->fetchAssoc() );
  }

  public function display_view(){
    switch (self::$action) {
      case 'delete':
	if(self::test_oID((int)$_GET['oID'])) {
	  self::$oInfo=self::load_db_values((int)$_GET['oID']);
	  return tep_get_include_contents(self::$code.'.delete');
	}
      break;
      case 'multi_confirm':
	return tep_get_include_contents(self::$code.'.multi_confirm');
      break;
      case 'edit':
	if(self::test_oID((int)$_GET['oID'])) {
	  self::$oID=(int)$_GET['oID'];
	  self::$order= new order(self::$oID);
	  return tep_get_include_contents(self::$code.'.edit');
	}
      break;
      default:
	self::$export= new export();
	self::tep_get_list();
	return tep_get_include_contents(self::$code.'.listing');
    }
  }



/** Iterne public module */
  public static function init(){
    global $languages_id;
    $DB=Database::getInstance();
    self::$orders_statuses=array();
    $orders_status_query = $DB->query("select status_id, status_name from " . TABLE_STATUS . " where status_type='orders' and language_id = '" . (int)$languages_id . "'");
    while ($orders_status = $orders_status_query->fetchAssoc()) {
      self::$orders_statuses[] = array('id' => $orders_status['status_id'], 'text' => $orders_status['status_name']);
      self::$orders_status_array[$orders_status['status_id']] = $orders_status['status_name'];
    }
  }


  public static function load_status_history($oID){
    self::init();
    $list=array();
    $DB=Database::getInstance();
    $orders_history_query = $DB->query("select orders_status_id, date_added, customer_notified, comments from " . TABLE_ORDERS_STATUS_HISTORY . " where orders_id = '" . tep_db_input($oID) . "' order by date_added");
    if ($orders_history_query->__get('numRows')) {
      while ($orders_history = $orders_history_query->fetchAssoc()) {
	self::$update=(DEFAULT_ORDERS_STATUS_COMPLETED== $orders_history['orders_status_id'])? false : true;

	$li['date_added']=tep_datetime_short($orders_history['date_added']);
	$li['customer_notified']=(($orders_history['customer_notified'] == '1')? tep_image(DIR_WS_ICONS . 'tick.gif', ICON_TICK) :tep_image(DIR_WS_ICONS . 'cross.gif', ICON_CROSS) ) ;
	$li['orders_status']=self::$orders_status_array[$orders_history['orders_status_id']];
	$li['comments']=nl2br(tep_db_output($orders_history['comments'])) ;
	$list[]=$li;
// 	echo '<tr>' . "\n" .
// 	    '<td colspan="5">' . __('text no order history') . '</td>' . "\n" .
// 	    '</tr>' . "\n";
      }
      return $list;
    }
    return false;
  }



 /** static InterfacedTJsonS */


  private static function emptyResult(){
    $li=array();
    foreach(self::tep_get_modele() as $k=>$v) $li[$k]='&nbsp;';
    return $li;
  }

  /**
    @fn get_item_action($orders)
    @brief fonction qui construit l'affichage de la colonne action
      La mise en forme est contenu dans les ressource xml du template en cours
    @param $orders array
    @return string
  */
  private static function get_item_action($orders){
    return  sprintf(
		  CsrtAction::getFormat('row_action'),
		  '' ,
		  sprintf(CsrtAction::getLink('row_action_right', IMAGE_EDIT, 'edit'), '',  tep_href_link(self::FILENAME, 'oID=' . $orders['oID'] . '&amp;action=edit') ,'' ).
		  sprintf(CsrtAction::getLink('row_action_right', IMAGE_DELETE, 'delete'), 'fancy',  tep_href_link(self::FILENAME, 'oID=' . $orders['oID'] . '&amp;action=delete') ,'' )
		);
  }


  public static function tep_get_modele(){
    return array( 0 =>false,
		  1 =>false,
		  'orders_id'=>true,
                  'customers_id'=>true,
                  'order_total'=>true,
		  'date_purchased'=>true,
		  'payment_method'=>true,
                  'orders_status_name'=>true,
		  'action' =>false
                );
  }


  public static function tep_get_list($page=1,$rowbyp=10,$sOrder='',$sWhere='',$options=''){
    global $query_numrows,$languages_id;

    $DB=Database::getInstance();

    if(tep_not_null($sWhere)){
      $sWhere=str_replace(array('orders_id',
				'order_total',
				'customers_id',
				'orders_status_name'),
			  array('o.orders_id',
				' ot.text',
				'o.customers_name',
				's.status_name'),
	      $sWhere);
    }

    $query_raw = "select distinct o.orders_id,o.orders_prefix, o.customers_id, o.customers_name, o.payment_method, o.date_purchased, o.last_modified, o.currency, o.currency_value, s.status_name as orders_status_name, s.status_color as orders_status_color, ot.text as order_total from " . TABLE_ORDERS . " o left join " . TABLE_ORDERS_TOTAL . " ot on (o.orders_id = ot.orders_id), " . TABLE_STATUS . " s where o.orders_status = s.status_id  and s.status_type='orders' and s.language_id = '" . (int)$languages_id . "' and ot.class = 'ot_total' ".$sWhere." order by  ".((!empty($sOrder)) ? $sOrder : 'o.orders_id DESC');

    $orders_split = new splitPageResults($page, $rowbyp, $query_raw, $query_numrows);
    $orders_query = $DB->query($query_raw);

    while ($orders = $orders_query->fetchAssoc()) {
	$ord['oID']=$orders['orders_id'];
	$ord['orders_id']=$orders['orders_prefix'].$orders['orders_id'];
	$ord['customers_id']=tep_customers_row_action($orders['customers_id'], array('origin'=>self::FILENAME));
	$ord['order_total']=strip_tags($orders['order_total']);
	$ord['date_purchased']=tep_datetime_short($orders['date_purchased']);
	$ord['payment_method']=$orders['payment_method'];
	$ord['orders_status_name']='<span style="display:inline-block; width:100%;padding:3px 0;background:'.$orders['orders_status_color'].'" >'.$orders['orders_status_name'].'</span>';
	$ord[0]=$orders['orders_id'];
	$ord[1]=tep_draw_checkbox_field('action_multi['.$orders['orders_id'].']','action_mutli_'.$orders['orders_id'],$orders['orders_id']);
	$ord['action']=self::get_item_action($ord);
	self::$list[]=$ord;
    }

    $li=$res=array();
    foreach(self::$list as $item){
      foreach(self::tep_get_modele() as $k=>$v) $li[$k]=(isset($item[$k]) && !empty($item[$k]))? $item[$k] : '&nbsp;';
      $res[]=$li;
    }

    if(count($res)==0) $res[]=self::emptyResult();
    return $res;
  }

 /** static InterfacedInnerHtml */

  public static function detail_row_page($id){
    self::$list=self::load_status_history($id);
    return tep_get_include_contents(__CLASS__.'.inline');
  }

/** Interne module  */

  private static function test_oID($oID){
    global $messageStack;
    $_oID = tep_db_prepare_input($oID);
    $DB=Database::getInstance();

    $orders_query = $DB->query("select orders_id from " . TABLE_ORDERS . " where orders_id = '" . (int)$_oID . "'");
    $order_exists = true;
    if (!$orders_query->__get('numRows')) {
      $order_exists = false;
      $messageStack->add(sprintf(__('error order does not exist'), $_oID), 'error');
    }


    return $order_exists;
  }
}

?>