<?php if (!defined('HTTP_SERVER')) die('You can not access this file directly!');
/**
  @licence GPL 2005-2010  The osCSS developers - osCSS Open Source E-commerce
  @portion code Copyright (c) 2002 osCommerce
  @Copyright (c) 2008 Box 25 http://www.box25.net
  @package osCSS-2 <www http://www.oscss.org>
  @version 2.1.0
  @date  21/12/10, 13:25
  @author oscim <mail aurelien@oscim.fr> <www http://www.oscim.fr>
  @encode UTF-8
  @class image_ratio
*/
class image_ratio {

  protected static $_instance;

  /**
    PHP 5 Constructor
  */
  private function __construct() {
  }

  public static function getInstance() {
      if(self::$_instance == null) {
    self::$_instance = new self();
      }
      return self::$_instance;
  }

  public static function resetInstance() {
      self::$_instance = null;
      return self::getInstance();
  }

  /**
    @package oscss-2
    @author OscssTeam
    The HTML image wrapper function
    @param
      @a string $src
      @a string $alt
      @a numeric $width/$height
      @a string $parameters
      @a bool/string $mode (true=url, false=normal, simple= sans width et height)
  */
  function tep_image($src, $alt = '', $width = '', $height = '', $parameters = '',$mode=false) {

    global $page;
    if (defined('DIR_WS_ADMIN')){
      if (strpos($src, DIR_WS_ADMIN) >0 || ( strpos($src, DIR_WS_IMAGES) ==0  && file_exists(DIR_FS_ADMIN.$src) ) ) $src_dir = DIR_FS_ADMIN . $src;
      else  $src_dir = DIR_FS_CATALOG . substr ($src, (strrpos (DIR_WS_CATALOG , '/')));
    }
    else $src_dir=$src;

    if (!@is_file($src_dir) || empty($src_dir)){
      if ( _cst_bool('IMAGE_REQUIRED')) return '<span class="errorText">Le fichier n\'a pas pu être trouvé sur le serveur !</span>';
      return false;
    }
    elseif ( ($imagedata = getimagesize($src_dir)) == false || !$imagedata[2] || $imagedata[2] > 3) {
      if (empty($alt)) return '<span class="errorText">Ce format d\'image n\'est pas autorisé !</span>';
      else return '<span class="errorText">' . tep_output_string($alt) . '!</span>';
    }
    else {
      $image_size = self::aspectratio($imagedata[0], $imagedata[1], $width, $height);
      $width = $image_size["width"];
      $height = $image_size["height"];
      if (function_exists('imagecreatetruecolor') && $width != $imagedata[0] && $height != $imagedata[1]) {
        $src=self::thumbfile($src, $width, $height, $imagedata[0], $imagedata[1], $imagedata[2], DIR_WS_IMAGES . 'imagecache/');
      }
    }

    if(is_bool($mode) && $mode){
      if (defined('DIR_WS_ADMIN')) return tep_output_string($src);
      return tep_output_string(tep_get_httpdir().$src);
    }
    else {
      $image = '<img src="' . (!defined('DIR_WS_ADMIN') ? tep_output_string(tep_get_httpdir().$src) : tep_output_string($src)) . '" alt="' . tep_output_string($alt) . '" ';
      if($mode !='simple') $image .= 'width="' . $width . '" height="' . $height . '"';
      if (tep_not_null($alt))  $image .= ' title="' . tep_output_string($alt) . '"';
      if (tep_not_null($parameters)) $image .= ' ' . $parameters;
      $image .= ' />';
      return $image;
    }
  }


  /**
    @package oscss-2
    @author Ayatus
    Redimensionnement des images en conservant leurs proportions
    @param
      @a string path.src img
      @a float/empty max width en px
      @a float/empty max height en px
    @return array (width,height)
  */
  function aspectratio ($width_src , $height_src , $max_width = '', $max_height = ''){

    error_reporting(E_ALL);

    !empty ($max_width) && preg_match ('/^[0-9]{1,}$/', $max_width, $regs) && $max_width <= $width_src
    ? true
    : $max_width = $width_src;
    !empty ($max_height) && preg_match ('/^[0-9]{1,}$/', $max_height, $regs) && $max_height <= $height_src
    ? true
    : $max_height = $height_src;
    $width=$max_width;
    $height=$max_height;

    if ($max_width == $max_height){
      if ($width_src < $height_src){
        $width=ceil($max_width * $width_src / $height_src);
        $height=$max_width;
      }
      elseif ($width_src > $height_src) $height=ceil($max_width * $height_src / $width_src);
      elseif ($width_src == $height_src) $height=$max_width;
    }
    elseif (($max_width * $height_src / $width_src) > $max_height) $width=ceil($max_height * $width_src / $height_src);
    elseif (($max_height * $width_src / $height_src) > $max_width) $height=ceil($max_width * $height_src / $width_src);
    elseif ($width_src == $height_src){
      if ($max_width > $max_height) $width=$max_height;
      elseif ($max_width < $max_height) $height=$max_width;
    }

    return array("width"=>$width,"height"=>$height);
  }

  function thumbfile ($image, $width, $height, $width_src, $height_scr, $format, $cachedir){

    error_reporting(E_ALL);

    umask(0);
    !is_dir ($cachedir) ? mkdir ($cachedir, 0777) : @chmod ($cachedir, 0777);

    if (defined('DIR_FS_ADMIN')){
      if (strpos($image, DIR_WS_CATALOG) === false) $image = DIR_FS_ADMIN . $image;
      else $image = DIR_FS_CATALOG . substr ($image, (strrpos (DIR_WS_CATALOG , '/'))+1);
   }

    $types = array (1 => "gif", "jpeg", "png");

    $thumb = $width.'x'.$height.'_'.basename($image).'_'.md5($image).'.'.(($types[$format]=="jpeg") ? "jpg" : $types[$format]);
    $thumbfile = $cachedir.$thumb;
    if (file_exists ($thumbfile)) {
      $thumbdata = getimagesize ($thumbfile);
      $thumbdata[0] == $width && $thumbdata[1] == $height ? $iscached = true : $iscached = false;
      if (@filemtime($thumbfile) < @filemtime($image)) $iscached = false;
    }
    else  $iscached = false;


    if (!$iscached)  $makethumb = ($width_src > $width || $height_scr > $height) ?  true : false;
    else $makethumb = false;

    if ($makethumb) {
      $image=self::thumbgd($image, $width, $height, $width_src, $height_scr, $types[$format], $thumbfile);
    }
    else {
      $image=($iscached) ? $thumbfile : substr ($image, (strrpos (DIR_FS_CATALOG , '/'))+1);
    }
    return $image;
  }

  /**
    @author by Christian Lamine, FlashDreams OHG   http://www.flashdreams.de/
      Modified by http://www.team-noehring.de
      Modified by http://www.tse.at
      Modified by lars@iwer.de
      Traduction Fr : cynic- pour OsCss
      Modified by oscim for oscss debug + php script
      Modified by Ayatus
    @version Thumbnail-Script v1.3
    Generating thumbnails 'on-the-fly' with PHP
    @note
      This script may be freely used, distribute
      and modified without any charge as long as
      this copyright information is included
      Any commercial selling of this script is forbidden.
  */
  function thumbgd ($image, $width, $height, $width_src, $height_scr, $format, $thumbfile){
    // error_reporting(E_ALL);
    $jpegquality = (defined('JPEG_QUALITY') ? JPEG_QUALITY :  95);

    /*if ($format == "gif" && class_exists('Imagick') && !ini_get('safe_mode')) {
      $thumb_gif = new Imagick($image);
      foreach ($thumb_gif as $frame) {
        $frame->thumbnailImage($width, $height);
        $frame->setImagePage($width, $height, 0, 0);
      }
      $thumb_gif->writeImages($thumbfile, true);
    }
    else {*/
      $image = call_user_func("imagecreatefrom".$format, $image);
      $thumb = imagecreatetruecolor ($width, $height);
      imagealphablending($thumb, false);
      imagesavealpha($thumb, true);
      imagefill($thumb, 0, 0, imagecolorallocatealpha($thumb, 0, 0, 0, 127));
      imagecopyresampled ($thumb, $image, 0, 0, 0, 0, $width, $height, $width_src, $height_scr);

      if ($format == "jpeg")  @call_user_func("image".$format, $thumb, $thumbfile, $jpegquality);
      else @call_user_func("image".$format, $thumb, $thumbfile);
      @imagedestroy ($image);
      @imagedestroy ($thumb);
    //}
    $image = $thumbfile;
  return $image;
  }

}
?>