<?php if (!defined('HTTP_SERVER')) die('You can not access this file directly!');
/**
  @licence GPL 2005-2010  The osCSS developers - osCSS Open Source E-commerce
  @package osCSS-2 <www http://www.oscss.org>
  @version 2.0.9h
  @author oscim <mail aurelien@oscim.fr> <www http://www.oscim.fr>
  @encode UTF-8
  @class listing
  \brief charge les modules actifs
*/

class listing 
  extends AbstractAcaModule 
	implements InterfaceAcaGene{

  /**
   * 
   * @var unknown_type
  */
  protected static $_instance;

  /**
   * \fn __construct() 
  */
  protected function __construct() {
    global $language, $page;
    $this-> name='listing';
    $this->modules=array();

    foreach(parent::initialise_type('MODULE_LISTING_INSTALLED','listing') as $class){
      $cl[$class]=new $class ();
      $list_mod[$class] = $cl[$class]->sort_order;
      asort($list_mod);
      foreach($list_mod as $class=>$s){
	$this->modules[$class] =$cl[$class];
      }
      unset($cl);unset($list_mod);
    }
  }

  /**
   * \fn getInstance()
   */
  public static function getInstance() {
    if(self::$_instance == null) self::$_instance = new self();
    return self::$_instance;
  }

  /**
   * \fn getInstance()
   */
  public static function resetInstance(){
    self::$_instance = null;
    return self::getInstance();
  }

  /**
   * \fn display_view($ID,$class='')
   * @param $ID int 
   * @param $class string
   */
  public function display_view($ID,$class=''){return array();}

  /**
   * \fn display_view_min($cID,$class='')
   * \brief unknown_type
   * @param $cID unknown_type
   * @param $class string class le nom de la class appelé, ou vide pour toutes les class enfants
   */
  public function display_view_min($cID,$class=''){
    global  $page;
    if (!empty($class)) {
      if (isset($this->modules[$class]) && $this->modules[$class]->enabled and (method_exists($module, 'display_view_min' ))){
        $this->modules[$class]->load_db_values($cID);
        return $this->modules[$class]->display_view_min($cID);
      }
    } else {
       $c='';
      foreach ($this->modules as $key=>$module) {
        if (($module->enabled)  and (method_exists($module, 'display_view_min' ))) {
          $this->modules[$key]->load_db_values($cID);
          $c .=$this->modules[$key]->display_view_min($cID);
        }
      }
      return $c;
    }
  }

 /**
  * \fn return_db_min($cID,$class='')
  * \brief  return_db_min module display_view mini
  * @param $cID
  * @param $class
  */
  public function return_db_min($cID,$class=''){
    global  $page;
    if (!empty($class)) {
      if (isset($this->modules[$class]) && $this->modules[$class]->enabled and (method_exists($module, 'return_db_min' ))){
        $this->modules[$class]->load_db_values($cID);
        return $this->modules[$class]->return_db_min($cID);
      }
    } else {
       $c=array();
      foreach ($this->modules as $key=>$module) {
        if (($module->enabled)  and (method_exists($module, 'return_db_min' ))) {
          $this->modules[$key]->load_db_values($cID);
          $c[$key]=$this->modules[$key]->return_db_min($cID);
        }
      }
      return $c;
    }
  }

}
?>