<?php
/**
 *\licence GPL 2005-2010  The osCSS developers - osCSS Open Source E-commerce
 *\portion code Copyright (c) 2002 osCommerce
 *\package osCSS-2 <www http://www.oscss.org>
 *\version 2.1.0
 *\date  28/11/10, 22:44
 *\author oscim <mail aurelien@oscim.fr> <www http://www.oscim.fr>
 *\encode UTF-8
 *\file 
 *\example example_RacinePage.php
 *\mainpage index.php
 *\brief process principal for display pages frontend  \n\n
 *\section introduction
 *		Ce fichier prend en charge la majorité des affichages public, il assure ainsi l'affichage des produits, catagorie, listing, content, home \n
 *		Les autres fichiers de la racine assure les traitements specialisé sur des affichage particulier . Dans tous les affichage generic, c'est ce fichier qui prend en charge l'affichage. 
 *	\n\n
 *		Pour Ajouter un fichier à la racine simplement, utiliser la base example 
*/
  require_once('includes/application_top.php');

  //! Choix du mode affichage des listign et priorité
  $category_depth = 'top';
  if (isset($cPath) && tep_not_null($cPath)) {
    if ( ($count_cat=categorie::get_has_category_subcategories((int)$current_category_id)) && $count_cat > 0)  $category_depth = 'nested'; // navigate through the categories
    elseif($current_category_id==0)$category_depth = 'top';
    else {
      $count_p=categorie::get_count_products_in_category((int)$current_category_id);
      $count_c=categorie::get_count_content_in_category((int)$current_category_id);

      if ($count_p > 0 && $count_p>=$count_c) $category_depth = 'products';
      elseif ($count_c > 0 && $count_c>=$count_p ) $category_depth = 'pages';
      else $category_depth = 'top';
    }
  }
  if(isset($_GET['type_object']) && tep_not_null($_GET['type_object']))$category_depth = $_GET['type_object'];
  if(isset($_GET['manufacturers_id']) && $category_depth == 'top') $category_depth = 'products';

  $page->add_var_page('category_depth',$category_depth);

if ($category_depth == 'top') {

/** 
 * \section Page Customer public 
 */
  if (isset($_GET['customers_id']) ) {
    $page->init('customers.php',$language);

    $aca_account=$account=$page->new_class('account',$customer_id);
    $account=$page->_call('customer','the_customer');
    $page_content = $page->force_content('customers.php');

  }elseif (isset($_GET['products_id']) ) {
    $page->init('404.php',$language);

    $page_content = $page->force_content('404.php');


 /** HOME */
  }else {
    $page->init('home.php',$language);

    $page_content = $page->force_content('home.php');
  }

  unset($category_cfils);
  unset($category_pfils);
  unset($category_parent);


/**
  Modes Avec heritage des informations sur la categories en cours,
*/
}else{

  /**
    element communs categories
  */
  // Get the right image for the top-right
    $image = DIR_WS_IMAGES . 'table_background_list.gif';

  if(!isset($_GET['manufacturers_id'])) {
    //! Recup des element cat en cours
      if( ($categories=categorie::get_item((int)$current_category_id)) ==false)  $category_depth='nofound' ;
      $image=$categories->categories_image;

    //! List des categorie enfant
      $categories_query = $DB->query($sql="select c.categories_id from " . TABLE_CATEGORIES . " c where c.parent_id = '" . (int)$current_category_id . "'  and c.categories_status='1' ");
      $lis='';
      while ($cat= $categories_query->fetchAssoc() ){ $lis .="'".$cat['categories_id']."',"; }
      $categories->list=$list=substr($lis,0,strlen($lis)-1);

      if(isset($count_p))$categories->products_total=$count_p;
      if(isset($count_c))$categories->contents_total=$count_c;
      if(isset($count_cat))$categories->categories_total=$count_cat;

      unset($count_p); unset($count_c); unset($count_cat);
      /**
	Stock la categories en cours
	@param array (categories_name, categories_description, categories_image, list,products_total,contents_total,categories_total )
      */
      $page->add_var_page('categories',$categories);

  }


/** Page produits */
  if (/*$category_depth == 'products' &&*/ isset($_GET['products_id']) ) {
    $page->init('product_info.php',$language);

    /** init aca module */
    $aca_product=$page->new_class('product',true);

    if (isset($_GET['action'])) {
        if ($aca_product->check_action('',$_GET['action']) ) {
          $aca_product->after_check_action('',$_GET['action']);
          tep_redirect(tep_href_link(FILENAME_PRODUCT_INFO, tep_get_all_get_params(array('action'))));
        }
    }

    //! produit nom trouvé
    if  ( ($obj_product_info =product_info((int)$_GET['products_id'])) ==false ) tep_redirect(tep_href_link(FILENAME_DEFAULT) );
    $product_info=arrayInfo($obj_product_info);
    $page->add_var_page('product_info',$product_info);
    $page->title=$product_info['title'];
    $breadcrumb->add($product_info['title'], tep_href_link(FILENAME_PRODUCT_INFO, 'products_id=' . $_GET['products_id'].'&amp;cPath=' . $cPath . ''));

    /**
      Incremente nbr de vus du produits
    */
    $DB->query("update " . TABLE_PRODUCTS_DESCRIPTION . " set products_viewed = products_viewed+1 where products_id = '" . (int)$_GET['products_id'] . "' and language_id = '" . (int)$languages_id . "'");

    /**
    Specifique au bloite récement vu. Enregistrement désactivier si OSCSS__B_RECENTLY_VIEWED et a false
    */
    if($page->_conf_value('OSCSS__B_RECENTLY_VIEWED')) {
      if (!tep_session_is_registered('recently_viewed')){
        tep_session_register('recently_viewed');
        $recently_viewed = $_GET['products_id'] . ';';
      }
      $check_not_duplicate = $_GET['products_id'];
      $temp_recent = $recently_viewed;
      if (preg_match('/'.$check_not_duplicate.'/', $temp_recent ) )  $recently_viewed = preg_replace('/'.$check_not_duplicate.'/',"",$temp_recent);
      $recently_viewed = $_GET['products_id'] . ';' . $recently_viewed ;
    }
    $page->product->pile_img[]=$product_info['products_image'];
    $page_content = $page->force_content(FILENAME_PRODUCT_INFO);


/** Listing Cat */
    } elseif ( $category_depth == 'nested') {
    $page->init(basename(__FILE__),$language);

    $listing_sql = "select DISTINCT p.*, pd.products_name from ".TABLE_V_PRODUCTS." p, " . TABLE_PRODUCTS_DESCRIPTION . " pd,  " . TABLE_PRODUCTS_TO_CATEGORIES . " p2c WHERE   pd.products_id = p.products_id and pd.language_id = '" . (int)$languages_id . "' and p.products_id = p2c.products_id ".(tep_not_null($list)? " AND  p2c.categories_id IN (" . $list . ")" : '');

    $listing_split = new splitPageResults($listing_sql,  $page->_conf_value('MAX_DISPLAY_PAGE_LINKS'), 'p.products_id');
    $listing_query = $DB->query($listing_split->sql_query);

    $page_content = $page->force_content('index_listing.php');

/** Listing Produits/ PAGE  */
  } elseif  (in_array($category_depth,array( 'products', 'pages')) ) {

    $page->init(basename(__FILE__),$language);
// create column list
    $define_list = array('PRODUCT_LIST_MODEL' => _cst_bool('PRODUCT_LIST_MODEL'),
                         'PRODUCT_LIST_NAME' => _cst_bool('PRODUCT_LIST_NAME'),
                         'PRODUCT_LIST_MANUFACTURER' => _cst_bool('PRODUCT_LIST_MANUFACTURER'),
                         'PRODUCT_LIST_PRICE' => _cst_bool('PRODUCT_LIST_PRICE'),
                         'PRODUCT_LIST_QUANTITY' => _cst_bool('PRODUCT_LIST_QUANTITY'),
                         'PRODUCT_LIST_WEIGHT' => _cst_bool('PRODUCT_LIST_WEIGHT'),
                         'PRODUCT_LIST_IMAGE' => _cst_bool('PRODUCT_LIST_IMAGE'),
                         'PRODUCT_LIST_BUY_NOW' => _cst_bool('PRODUCT_LIST_BUY_NOW'));

    asort($define_list);

    $column_list = array();
    reset($define_list);
    while (list($key, $value) = each($define_list)) {
      if ($value > 0) $column_list[] = $key;
    }

    if (isset($_GET['manufacturers_id'])) {
      $listing_sql = " SELECT DISTINCT pd.products_name , p.* FROM  ".TABLE_V_PRODUCTS." p
			LEFT JOIN  " . TABLE_PRODUCTS_DESCRIPTION . " pd ON ( pd.products_id = p.products_id)
			LEFT JOIN   " . TABLE_PRODUCTS_TO_CATEGORIES . " p2c ON ( p2c.products_id= p.products_id )
			WHERE pd.language_id = '" . (int)$languages_id . "' AND  p.manufacturers_id = '" . (int)$_GET['manufacturers_id'] . "' ";

      if (isset($_GET['filter_id']) && tep_not_null($_GET['filter_id']))
	$listing_sql .= " and  p2c.categories_id = '" . (int)$_GET['filter_id'] . "'";

    } else {
    // show the products in a given categorie
    //! We show them all and all type (page, products,link )
      if((isset($_GET['type_object']) && $_GET['type_object']=='products') || $category_depth=='products'){
	$listing_sql = " select distinct p.*, pd.products_name from  ".TABLE_V_PRODUCTS." p
			  LEFT JOIN  " . TABLE_PRODUCTS_DESCRIPTION . " pd on pd.products_id = p.products_id
			  LEFT JOIN   " . TABLE_PRODUCTS_TO_CATEGORIES . " p2c on p2c.products_id= p.products_id
			  WHERE pd.language_id = '" . (int)$languages_id . "' and  p2c.categories_id = '" . (int)$current_category_id . "' ";

	if (isset($_GET['filter_id']) && tep_not_null($_GET['filter_id']))
	  $listing_sql .=" and p.manufacturers_id = '" . (int)$_GET['filter_id'] . "'";

	}elseif((isset($_GET['type_object']) && $_GET['type_object']=='pages') || $category_depth=='pages')
	$listing_sql = "select  c.content_id,ctc.categories_id, content_name,content_title,content_text, c.date_added, c.last_modified, content_status, ctc.categories_id    from " . TABLE_CONTENT_DESCRIPTION . " cd, " . TABLE_CONTENT . " c,   " . TABLE_CONTENT_TO_CATEGORIES . " ctc, " . TABLE_CATEGORIES . " cat where cat.categories_id=ctc.categories_id and cat.categories_status='1' and c.content_status = '1' and c.content_id = ctc.content_id and cd.content_id = ctc.content_id and cd.language_id = '" . (int)$languages_id . "' and cat.categories_id = '" . (int)$current_category_id . "'";
    }


    if ((isset($_GET['type_object']) && $_GET['type_object']=='products') || $category_depth=='products')
      if ( (!isset($_GET['sort'])) || (!preg_match('/[1-8][ad]/', $_GET['sort'])) || (substr($_GET['sort'], 0, 1) > sizeof($column_list)) ) {
	for ($i=0, $n=sizeof($column_list); $i<$n; $i++) {
	  if ($column_list[$i] == 'PRODUCT_LIST_NAME') {
	    $_GET['sort'] = $i+1 . 'a';
	    if(!isset($_GET['type_object']) || $_GET['type_object']=='products') $listing_sql .= " order by pd.products_name";
	    break;
	  }
	}
      } else {
	$sort_col = substr($_GET['sort'], 0 , 1);
	$sort_order = substr($_GET['sort'], 1);
	if(!isset($_GET['type_object']) || $_GET['type_object']=='products') {
	  $listing_sql .= ' order by ';
	  switch ($column_list[$sort_col-1]) {
	    case 'PRODUCT_LIST_MODEL': $listing_sql .= "p.products_model " . ($sort_order == 'd' ? 'desc' : '') . ", pd.products_name"; break;
	    case 'PRODUCT_LIST_NAME': $listing_sql .= "pd.products_name " . ($sort_order == 'd' ? 'desc' : ''); break;
	    case 'PRODUCT_LIST_MANUFACTURER': $listing_sql .= "m.manufacturers_name " . ($sort_order == 'd' ? 'desc' : '') . ", pd.products_name"; break;
	    case 'PRODUCT_LIST_QUANTITY': $listing_sql .= "p.products_quantity " . ($sort_order == 'd' ? 'desc' : '') . ", pd.products_name"; break;
	    case 'PRODUCT_LIST_IMAGE': $listing_sql .= "pd.products_name"; break;
	    case 'PRODUCT_LIST_WEIGHT': $listing_sql .= "p.products_weight " . ($sort_order == 'd' ? 'desc' : '') . ", pd.products_name"; break;
	    case 'PRODUCT_LIST_PRICE': $listing_sql .= "final_price " . ($sort_order == 'd' ? 'desc' : '') . ", pd.products_name"; break;
	  }
	}
      }

    /// get the categorie name and put it on the header
    if (isset($_GET['manufacturers_id'])) {
      $man=$DB->query("select * from " . TABLE_MANUFACTURERS . " m  where m.manufacturers_id = '" . (int)$_GET['manufacturers_id'] . "' ");
      $manuf= $man->fetchAssoc();
      tep_db_free_result($man);
      $image = $manuf['manufacturers_image'];
      $page->breadcrumb->add($manuf['manufacturers_name'], tep_href_link(FILENAME_DEFAULT, 'manufacturers_id=' . $_GET['manufacturers_id']));
      $page->add_var_page('manufacturers',$manuf);
    }

    if((isset($_GET['type_object']) && $_GET['type_object']=='products') || $category_depth=='products' || isset($_GET['manufacturers_id'])) $listing_split = new splitPageResults($listing_sql,  $page->_conf_value('MAX_DISPLAY_PAGE_LINKS'), 'p.products_id');
    else $listing_split = new splitPageResults($listing_sql,  $page->_conf_value('MAX_DISPLAY_PAGE_LINKS'));

    $listing_query = $DB->query($listing_split->sql_query);
    $page_content = $page->force_content('index_listing.php');

  } elseif ( $category_depth == 'nofound') {
    $page->init(basename(__FILE__),$language);

    $page_content = $page->force_content('404.php');
  }

}


  $page->post_init(false);
  require($page->path_gabarit());

  require(DIR_WS_INCLUDES . 'application_bottom.php');
?>